package robotserver;

import javax.swing.SwingUtilities;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.io.PrintWriter;
import java.net.Socket;
import javax.swing.JButton;
import java.awt.FlowLayout;
import javax.swing.JDialog;
import java.awt.BorderLayout;
import javax.swing.JLabel;


/**
 * @author ppeters
 *
 */
public class RobotClientTemplate {
	private JFrame jFrame = null; // @jve:decl-index=0:visual-constraint="7,-3"
	private JPanel jContentPane = null;
	private JButton jButton = null;
	private JButton jButton1 = null;
	private JButton jButton2 = null;
	private JButton jButton3 = null;

	private final int portNumber = 5050;
	private Socket socket = null;
	private PrintWriter pw = null;
	private JDialog jDialog = null;  //  @jve:decl-index=0:visual-constraint="6,77"
	private JPanel jContentPane1 = null;
	private JLabel jLabel = null;
	private JButton jButton4 = null;
	
	/**
	 * Constructor
	 * 
	 */
	public RobotClientTemplate() {
		try {
			socket = new Socket("localhost",portNumber);
			pw = new PrintWriter(socket.getOutputStream());
		} catch (java.io.IOException e) {
			getJDialog().setVisible(true);
			//System.err.println("Could not connect to robot server, is it started?.");
		}
	}

	/**
	 * This method send a string on the printwriter connected to the socket outputstream
	 * 
	 * @param s : string to send 
	 *            
	 */
	private void Send(String s) {
		if (pw != null) {
			pw.println(s);
			pw.flush();
		}
	}

	/**
	 * This method initializes jFrame
	 * 
	 * @return javax.swing.JFrame
	 */
	private JFrame getJFrame() {
		if (jFrame == null) {
			jFrame = new JFrame();
			jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			jFrame.setSize(328, 74);
			jFrame.setContentPane(getJContentPane());
			jFrame.setTitle("Robot client");
		}
		return jFrame;
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new FlowLayout());
			jContentPane.add(getJButton1(), null);
			jContentPane.add(getJButton2(), null);
			jContentPane.add(getJButton(), null);
			jContentPane.add(getJButton3(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Forward");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					/* 
					 * 
					 * FILL IN WHAT NEEDS TO BE DONE HERE
					 * 
					 */
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("Backward");
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					/* 
					 * 
					 * FILL IN WHAT NEEDS TO BE DONE HERE
					 * 
					 */
				}
			});
		}
		return jButton1;
	}

	/**
	 * This method initializes jButton2
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setText("Stop");
			jButton2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					/* 
					 * 
					 * FILL IN WHAT NEEDS TO BE DONE HERE
					 * 
					 */
				}
			});
		}
		return jButton2;
	}

	/**
	 * This method initializes jButton3
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new JButton();
			jButton3.setText("Red");
			jButton3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					/* 
					 * 
					 * FILL IN WHAT NEEDS TO BE DONE HERE
					 * 
					 */
				}
			});
		}
		return jButton3;
	}

	/**
	 * This method initializes jDialog	
	 * 	
	 * @return javax.swing.JDialog	
	 */
	private JDialog getJDialog() {
		if (jDialog == null) {
			jDialog = new JDialog(getJFrame());
			jDialog.setModal(true);
			jDialog.setContentPane(getJContentPane1());
			jDialog.pack();
		}
		return jDialog;
	}

	/**
	 * This method initializes jContentPane1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJContentPane1() {
		if (jContentPane1 == null) {
			BorderLayout borderLayout = new BorderLayout();
			borderLayout.setHgap(0);
			borderLayout.setVgap(0);
			jLabel = new JLabel();
			jLabel.setText(" Failed to connect to robot server... Is it running? ");
			jContentPane1 = new JPanel();
			jContentPane1.setLayout(borderLayout);
			jContentPane1.add(jLabel, BorderLayout.NORTH);
			jContentPane1.add(getJButton4(), BorderLayout.EAST);
		}
		return jContentPane1;
	}

	/**
	 * This method initializes jButton4	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton4() {
		if (jButton4 == null) {
			jButton4 = new JButton();
			jButton4.setText("Close");
			jButton4.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					getJDialog().setVisible(false);
					System.exit(1);
				}
			});
		}
		return jButton4;
	}

	/**
	 * Launches this application
	 */
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				RobotClientTemplate application = new RobotClientTemplate();
				application.getJFrame().setVisible(true);
			}
		});
	}

}
